#include <WellyNet.h>

#define COM_PIN 5 //AKA MISO
#define WN_ADDRESS 0x02
#define MOSI 6
#define DND 4 //DND is sck line

WellyNet myWelly(COM_PIN,WN_ADDRESS);

static int redpin = 8; //asign variable integer as a static number - dont change!
static int bluepin = 2;
static int greenpin = 7;

int message[10];


byte address = WN_ADDRESS;
byte destination = 0x5; //assign destination to a variable

void setup(){
  myWelly.begin(9600);
  pinMode (redpin, OUTPUT);
  pinMode (bluepin, OUTPUT);
  pinMode (greenpin,OUTPUT);
  pinMode (MOSI, INPUT);
  digitalWrite (redpin, LOW);
  delay(500);
  digitalWrite (redpin,HIGH);
 
}

void bens_magic() {
  digitalWrite(redpin, LOW);
  delay (500);
  digitalWrite(redpin, HIGH);
  digitalWrite(bluepin, LOW);
  delay (500);
  digitalWrite(bluepin, HIGH);
  digitalWrite(greenpin, LOW);
  delay (500);
  digitalWrite (greenpin, HIGH);
}

uint16_t message_type(int message[]) { //combining packets 3 and 4
  return message[2];
}

int message_payload(int message[]) {
  return message[3];
}

void dispatch_event_message(int message[]) {
  switch(message_payload(message)) {
    case 1:
      bens_magic();
      break;
    case 2:
      // event type 2
      break;
    default:
      // Unknown event
      break;
  } 
}


void loop(){
  digitalWrite (redpin,HIGH); //rgbled turns off when you pull it high. WHY? WHO KNOWS!!
  digitalWrite (bluepin, HIGH);
  digitalWrite (greenpin, HIGH);
 if (myWelly.getPacket(message)){ //if the packet is addressed to me
     digitalWrite (redpin,HIGH);
     delay (500);
     digitalWrite (redpin, LOW);
   int checksum = checksumCalc(message); //check the packet
   
   if (message[9] != checksum) {  // value 9 is packet checksum
     return;
   }
   // Check the message checksum, bail if it doesn't match
   
   if(message_type(message) == 'E ') {
     dispatch_event_message(message);
     
   } else {
     // Unknown message type 
   }
   
 }
 
 
}
